X-Git-Url: https://git.rohieb.name/openwrt.git/blobdiff_plain/a9d604c520514c74ff00ca19e43337a9ad2e1443..697a309ede936843ca8e1510827f0e7544237873:/package/base-files/files/sbin/mount_root?ds=sidebyside

diff --git a/package/base-files/files/sbin/mount_root b/package/base-files/files/sbin/mount_root
index 80078b516..835d60255 100755
--- a/package/base-files/files/sbin/mount_root
+++ b/package/base-files/files/sbin/mount_root
@@ -2,30 +2,24 @@
 # Copyright (C) 2006 OpenWrt.org
 . /etc/functions.sh
 
-mount none /proc -t proc
-size=$(awk '/Mem:/ {l=5242880;print((s=$2/2)<l)?$2-l:s}' /proc/meminfo)
-mount none /tmp -t tmpfs -o size=$size,nosuid,nodev,mode=1777
-if grep devfs /proc/filesystems > /dev/null; then
-	mount none /dev -t devfs
-else
-	mount -t sysfs none /sys
-	mount -t tmpfs tmpfs /dev -o size=512K
-	mknod /dev/console c 5 1
-	exec >/dev/console </dev/console 2>&1
-	mkdir /dev/shm
-	/sbin/hotplug2 --no-persistent --coldplug --max-children 1
-fi
-mkdir -p /dev/pts
-mount none /dev/pts -t devpts
+jffs2_ready () {
+	mtdpart="$(find_mtd_part rootfs_data)"
+	magic=$(hexdump $mtdpart -n 4 -e '4/1 "%02x"')
+	[ "$magic" != "deadc0de" ]
+}
 
-[ failsafe != "$1" ] && {
-	grep rootfs /proc/mtd >/dev/null 2>/dev/null && {
-		mtd unlock rootfs
-		grep rootfs_data /proc/mtd >/dev/null 2>/dev/null && {
-			. /bin/firstboot
-			echo "switching to jffs2"
-			mount "$(find_mtd_part rootfs_data)" /jffs -t jffs2
+grep rootfs_data /proc/mtd >/dev/null 2>/dev/null && {
+	. /bin/firstboot
+	mtd unlock rootfs_data
+	jffs2_ready && {
+		echo "switching to jffs2"
+		mount "$(find_mtd_part rootfs_data)" /jffs -t jffs2 && \
 			fopivot /jffs /rom
-		}
-	} || mount -o remount,rw /dev/root /
+	} || {
+		echo "jffs2 not ready yet; using ramdisk"
+		ramoverlay
+	}
+} || {
+	mtd unlock rootfs
+	mount -o remount,rw /dev/root /
 }